import { defineComponent as M, computed as x, createElementBlock as o, openBlock as n, normalizeClass as k, createCommentVNode as S, renderSlot as w, createTextVNode as ne, createElementVNode as t, Fragment as y, renderList as _, toDisplayString as h, ref as $, h as te, onMounted as E, watch as N, withDirectives as U, createVNode as W, isRef as Te, vModelCheckbox as Me, unref as A, defineAsyncComponent as Be, onBeforeUnmount as Oe, normalizeStyle as Ie, createBlock as re, resolveDynamicComponent as ie, mergeProps as ue, nextTick as de, onUnmounted as pe, vModelSelect as R, vModelText as ee } from "vue";
const Ue = {
  key: 0,
  class: "loading loading-spinner"
}, fn = /* @__PURE__ */ M({
  __name: "ButtonComponent",
  props: {
    outlined: { type: Boolean, default: !1 },
    active: { type: Boolean, default: !1 },
    loading: { type: Boolean, default: !1 },
    type: {},
    size: {},
    shape: {}
  },
  setup(d) {
    const u = d, e = x(() => {
      switch (u.size) {
        case "large":
          return "btn-lg";
        case "small":
          return "btn-sm";
        case "tiny":
          return "btn-tiny";
        case "wide":
          return "btn-wide";
        case "full":
          return "w-full";
        default:
          return "";
      }
    }), a = x(() => {
      switch (u.type) {
        case "neutral":
          return "btn-neutral";
        case "primary":
          return "btn-primary";
        case "secondary":
          return "btn-secondary";
        case "accent":
          return "btn-accent";
        case "ghost":
          return "btn-ghost";
        case "link":
          return "btn-link px-0!";
        case "info":
          return "btn-info";
        case "success":
          return "btn-success";
        case "warning":
          return "btn-warning";
        case "error":
          return "btn-error";
        default:
          return "btn-neutral";
      }
    }), i = x(() => {
      switch (u.shape) {
        case "square":
          return "btn-square";
        case "circle":
          return "btn-circle";
        default:
          return "";
      }
    });
    return (s, p) => (n(), o("button", {
      class: k(["btn", { "btn-outline": u.outlined }, { "btn-active": u.active }, a.value, e.value, i.value])
    }, [
      s.loading ? (n(), o("span", Ue)) : S("", !0),
      w(s.$slots, "default", {}, () => [
        p[0] || (p[0] = ne("Submit"))
      ])
    ], 2));
  }
}), Ae = {
  tabindex: "0",
  class: "z-1 bg-base-100 shadow-sm p-2 rounded-sm min-w-[inherit] md:min-w-full xl:min-w-52 dropdown-content menu"
}, Ve = ["href"], vn = /* @__PURE__ */ M({
  __name: "dropdown",
  props: {
    items: {},
    position: { default: "bottom" },
    floatPosition: { default: "start" },
    openOnHover: { type: Boolean, default: !1 },
    forceOpen: { type: Boolean, default: !1 }
  },
  setup(d) {
    const u = {
      left: "dropdown-left",
      right: "dropdown-right",
      bottom: "dropdown-bottom",
      top: "dropdown-top"
    }, e = {
      start: "",
      end: "dropdown-end"
    }, a = d;
    return (i, s) => (n(), o("div", {
      class: k(["dropdown", u[a.position], e[a.floatPosition], { "dropdown-open": a.forceOpen }, { "dropdown-hover": a.openOnHover }])
    }, [
      w(i.$slots, "default", {
        tabindex: "0",
        role: "button"
      }, () => [
        s[0] || (s[0] = t("div", { class: "m-1 btn" }, "Open dropdown", -1))
      ]),
      t("ul", Ae, [
        (n(!0), o(y, null, _(i.items, (p) => (n(), o("li", null, [
          t("a", {
            href: p.link
          }, h(p.text), 9, Ve)
        ]))), 256)),
        w(i.$slots, "additional")
      ])
    ], 2));
  }
}), Pe = { class: "modal-box" }, Re = { class: "modal-action" }, gn = /* @__PURE__ */ M({
  __name: "modal",
  props: {
    position: { default: "center" },
    withBackdrop: { type: Boolean, default: !1 }
  },
  setup(d) {
    const u = d, e = {
      top: "modal-top",
      bottom: "modal-bottom",
      center: "modal-middle"
    }, a = $(null), i = () => {
      var p;
      (p = a.value) == null || p.showModal();
    }, s = () => {
      var p;
      (p = a.value) == null || p.close();
    };
    return (p, b) => (n(), o(y, null, [
      t("span", {
        class: "w-fit cursor-pointer",
        onClick: i
      }, [
        w(p.$slots, "trigger", { role: "button" }, () => [
          b[0] || (b[0] = t("button", { class: "btn" }, "Open", -1))
        ])
      ]),
      t("dialog", {
        ref_key: "dialog",
        ref: a,
        class: k(["modal", e[u.position]])
      }, [
        t("div", Pe, [
          w(p.$slots, "default"),
          t("div", Re, [
            w(p.$slots, "actions"),
            t("form", {
              method: "dialog",
              onSubmit: s,
              class: k(p.withBackdrop ? "modal-backdrop" : "")
            }, [
              w(p.$slots, "close-button", {}, () => [
                b[1] || (b[1] = t("button", { class: "btn" }, "Close", -1))
              ])
            ], 34)
          ])
        ])
      ], 2)
    ], 64));
  }
}), je = { class: "swap-on" }, ze = { class: "swap-off" }, bn = /* @__PURE__ */ M({
  __name: "swap",
  props: {
    effect: {}
  },
  setup(d) {
    const u = d;
    return (e, a) => (n(), o("label", {
      class: k(["swap", u.effect ? `swap-${e.effect}` : ""])
    }, [
      a[0] || (a[0] = t("input", { type: "checkbox" }, null, -1)),
      t("div", je, [
        w(e.$slots, "on")
      ]),
      t("div", ze, [
        w(e.$slots, "off")
      ])
    ], 2));
  }
});
/**
 * @license lucide-vue-next v0.468.0 - ISC
 *
 * This source code is licensed under the ISC license.
 * See the LICENSE file in the root directory of this source tree.
 */
const Ne = (d) => d.replace(/([a-z0-9])([A-Z])/g, "$1-$2").toLowerCase();
/**
 * @license lucide-vue-next v0.468.0 - ISC
 *
 * This source code is licensed under the ISC license.
 * See the LICENSE file in the root directory of this source tree.
 */
var J = {
  xmlns: "http://www.w3.org/2000/svg",
  width: 24,
  height: 24,
  viewBox: "0 0 24 24",
  fill: "none",
  stroke: "currentColor",
  "stroke-width": 2,
  "stroke-linecap": "round",
  "stroke-linejoin": "round"
};
/**
 * @license lucide-vue-next v0.468.0 - ISC
 *
 * This source code is licensed under the ISC license.
 * See the LICENSE file in the root directory of this source tree.
 */
const Ee = ({ size: d, strokeWidth: u = 2, absoluteStrokeWidth: e, color: a, iconNode: i, name: s, class: p, ...b }, { slots: v }) => te(
  "svg",
  {
    ...J,
    width: d || J.width,
    height: d || J.height,
    stroke: a || J.stroke,
    "stroke-width": e ? Number(u) * 24 / Number(d) : u,
    class: ["lucide", `lucide-${Ne(s ?? "icon")}`],
    ...b
  },
  [...i.map((m) => te(...m)), ...v.default ? [v.default()] : []]
);
/**
 * @license lucide-vue-next v0.468.0 - ISC
 *
 * This source code is licensed under the ISC license.
 * See the LICENSE file in the root directory of this source tree.
 */
const ae = (d, u) => (e, { slots: a }) => te(
  Ee,
  {
    ...e,
    iconNode: u,
    name: d
  },
  a
);
/**
 * @license lucide-vue-next v0.468.0 - ISC
 *
 * This source code is licensed under the ISC license.
 * See the LICENSE file in the root directory of this source tree.
 */
const Le = ae("MoonIcon", [
  ["path", { d: "M12 3a6 6 0 0 0 9 9 9 9 0 1 1-9-9Z", key: "a7tn18" }]
]);
/**
 * @license lucide-vue-next v0.468.0 - ISC
 *
 * This source code is licensed under the ISC license.
 * See the LICENSE file in the root directory of this source tree.
 */
const ce = ae("SearchIcon", [
  ["circle", { cx: "11", cy: "11", r: "8", key: "4ej97u" }],
  ["path", { d: "m21 21-4.3-4.3", key: "1qie3q" }]
]);
/**
 * @license lucide-vue-next v0.468.0 - ISC
 *
 * This source code is licensed under the ISC license.
 * See the LICENSE file in the root directory of this source tree.
 */
const Fe = ae("SunIcon", [
  ["circle", { cx: "12", cy: "12", r: "4", key: "4exip2" }],
  ["path", { d: "M12 2v2", key: "tus03m" }],
  ["path", { d: "M12 20v2", key: "1lh1kg" }],
  ["path", { d: "m4.93 4.93 1.41 1.41", key: "149t6j" }],
  ["path", { d: "m17.66 17.66 1.41 1.41", key: "ptbguv" }],
  ["path", { d: "M2 12h2", key: "1t8f8n" }],
  ["path", { d: "M20 12h2", key: "1q8mjw" }],
  ["path", { d: "m6.34 17.66-1.41 1.41", key: "1m8zz5" }],
  ["path", { d: "m19.07 4.93-1.41 1.41", key: "1shlcs" }]
]), He = (d, u) => {
  const e = $(null);
  return E(() => {
    if (typeof window < "u") {
      const a = window.localStorage.getItem(d);
      e.value = a ? JSON.parse(a) : u;
    }
  }), N(e, (a) => {
    typeof window < "u" && window.localStorage.setItem(d, JSON.stringify(a));
  }), e;
}, qe = { class: "swap-rotate swap" }, Ye = ["true-value", "false-value"], hn = /* @__PURE__ */ M({
  __name: "theme-controller",
  props: {
    lightTheme: { default: "light" },
    darkTheme: { default: "dark" }
  },
  setup(d) {
    const u = d, e = He("theme", u.lightTheme);
    function a(i) {
      typeof window < "u" && window.document && document.documentElement.setAttribute("data-theme", i);
    }
    return E(() => a(e.value ? e.value : "")), N(e, (i) => {
      a(i);
    }), (i, s) => (n(), o("label", qe, [
      U(t("input", {
        type: "checkbox",
        class: "theme-controller",
        "onUpdate:modelValue": s[0] || (s[0] = (p) => Te(e) ? e.value = p : null),
        "true-value": u.lightTheme,
        "false-value": u.darkTheme
      }, null, 8, Ye), [
        [Me, A(e)]
      ]),
      W(A(Fe), { class: "swap-off fill-current" }),
      W(A(Le), { class: "swap-on fill-current" })
    ]));
  }
}), Je = ["name"], We = { class: "collapse-title font-bold text-2xl lg:text-4xl" }, Xe = { class: "collapse-content" }, Ze = ["innerHTML"], yn = /* @__PURE__ */ M({
  __name: "accordion",
  props: {
    name: {},
    items: {},
    joinItems: { type: Boolean, default: !1 },
    icon: {}
  },
  setup(d) {
    const u = d;
    return (e, a) => (n(!0), o(y, null, _(u.items, (i, s) => (n(), o("div", {
      class: k(["collapse border border-base-300", [e.icon ? `collapse-${e.icon}` : "", { "join-item": e.joinItems }]]),
      key: s
    }, [
      t("input", {
        type: "radio",
        name: e.name,
        value: "true"
      }, null, 8, Je),
      t("div", We, h(i.title), 1),
      t("div", Xe, [
        t("span", {
          innerHTML: i.content
        }, null, 8, Ze)
      ])
    ], 2))), 128));
  }
}), Ke = ["src"], Ge = { class: "text-xl" }, wn = /* @__PURE__ */ M({
  __name: "avatar",
  props: {
    image: {},
    onlineStatus: { default: "none" },
    initials: {},
    fullyRounded: { type: Boolean, default: !1 }
  },
  setup(d) {
    const u = d, e = $(u.onlineStatus);
    return N(
      () => u.onlineStatus,
      (a) => {
        a && (e.value = a);
      }
    ), (a, i) => (n(), o("div", {
      class: k(["avatar", [{ "avatar-online": e.value === "online" }, { "avatar-offline": e.value === "offline" }]])
    }, [
      a.image ? (n(), o("div", {
        key: 0,
        class: k(["rounded", [{ "rounded-full": a.fullyRounded }, { rounded: !a.fullyRounded }]])
      }, [
        t("img", {
          src: a.image,
          class: "w-full h-full"
        }, null, 8, Ke)
      ], 2)) : (n(), o("div", {
        key: 1,
        class: k(["flex justify-center bg-neutral p-[25%] rounded w-16 text-neutral-content text-center", [{ "rounded-full": a.fullyRounded }, { rounded: !a.fullyRounded }]])
      }, [
        t("p", Ge, h(a.initials), 1)
      ], 2))
    ], 2));
  }
}), kn = /* @__PURE__ */ M({
  __name: "badge",
  props: {
    color: { default: "neutral" },
    outline: { type: Boolean, default: !1 },
    size: { default: "medium" }
  },
  setup(d) {
    const u = d, e = {
      "extra small": "badge-xs",
      small: "badge-sm",
      medium: "badge-md",
      large: "badge-lg"
    }, a = {
      neutral: "badge-neutral",
      primary: "badge-primary",
      secondary: "badge-secondary",
      accent: "badge-accent",
      ghost: "badge-ghost",
      info: "badge-info",
      success: "badge-success",
      warning: "badge-warning",
      error: "badge-error"
    };
    return (i, s) => (n(), o("span", {
      class: k(["badge", e[u.size], a[u.color], { "badge-outline": u.outline }])
    }, [
      w(i.$slots, "default")
    ], 2));
  }
}), Qe = ["src", "alt"], et = {
  key: 1,
  class: "w-full h-32 skeleton"
}, tt = {
  key: 0,
  class: "card-body"
}, nt = {
  key: 0,
  class: "group-hover:text-primary text-left text-lg cursor-pointer card-title"
}, at = {
  key: 1,
  class: "text-left"
}, ot = { class: "flex-col flex-nowrap mt-auto card-actions" }, lt = {
  key: 1,
  class: "card-body"
}, _n = /* @__PURE__ */ M({
  __name: "card",
  props: {
    imgUrl: { default: "" },
    alt: { default: "A beautiful picture that says something about this card" },
    title: { default: "" },
    description: { default: "" },
    outlined: { type: Boolean, default: !1 },
    loading: { type: Boolean, default: !1 },
    class: { default: "" }
  },
  setup(d) {
    const u = d, e = $(u.outlined);
    return N(
      () => u.outlined,
      (a) => {
        e.value = a;
      }
    ), (a, i) => (n(), o("div", {
      class: k(["bg-base-100 shadow-xl rounded-sm min-w-64 max-w-full h-full card card-compact group", e.value ? "border-4 border-primary" : ""])
    }, [
      t("figure", null, [
        a.imgUrl || a.imgUrl && !a.loading ? (n(), o("img", {
          key: 0,
          src: a.imgUrl,
          alt: a.alt,
          class: k(["rounded-sm w-full h-44 object-cover", {
            hidden: a.loading
          }])
        }, null, 10, Qe)) : S("", !0),
        a.loading && a.imgUrl ? (n(), o("div", et)) : S("", !0)
      ]),
      a.loading ? S("", !0) : (n(), o("div", tt, [
        a.title ? (n(), o("h2", nt, h(a.title), 1)) : S("", !0),
        w(a.$slots, "details"),
        a.description ? (n(), o("p", at, h(a.description), 1)) : S("", !0),
        t("div", ot, [
          w(a.$slots, "actions")
        ])
      ])),
      a.loading ? (n(), o("div", lt, i[0] || (i[0] = [
        t("div", { class: "flex flex-col gap-4 w-52" }, [
          t("div", { class: "w-28 h-4 skeleton" }),
          t("div", { class: "w-full h-4 skeleton" }),
          t("div", { class: "w-full h-4 skeleton" })
        ], -1)
      ]))) : S("", !0)
    ], 2));
  }
}), st = { class: "flex gap-4 bg-base-100 w-full tabs tabs-boxed" }, rt = ["onClick"], it = { class: "text-sm" }, ut = { class: "md:block hidden opacity-35 text-xs truncate overflow-hidden ..." }, dt = { class: "hidden" }, ct = {
  id: "advancedSearchMobile",
  class: "modal"
}, pt = { class: "modal-box" }, mt = { class: "font-bold text-lg" }, ft = ["checked"], vt = { class: "flex justify-between items-center pr-4 w-full font-medium text-xl collapse-title" }, gt = { class: "text-sm" }, bt = { class: "flex place-content-center p-0 collapse-content" }, ht = /* @__PURE__ */ M({
  __name: "advancedSearch",
  props: {
    searchOptions: {},
    currentCategory: {}
  },
  emits: ["search", "update:search-data"],
  setup(d, { emit: u }) {
    const e = d, a = u, i = $(null), s = {
      datetime: Be(() => Promise.resolve().then(() => Lt))
    }, p = $({}), b = $({ left: "0px", top: "0px", transform: "translateX(0%)" }), v = $(null);
    function m(C, O) {
      var B, I, g;
      if ((B = i.value) != null && B.name) {
        a("update:search-data", {
          tab: i.value.name,
          data: C
        });
        return;
      }
      if (e.searchOptions) {
        let D = (g = (I = e.searchOptions) == null ? void 0 : I.find((V) => (V == null ? void 0 : V.category) === e.currentCategory)) == null ? void 0 : g.tabs[O];
        D !== void 0 && (D.value = C, a("update:search-data", {
          tab: D == null ? void 0 : D.name,
          data: D == null ? void 0 : D.value
        }));
      }
    }
    function f() {
      a("search");
    }
    async function j(C) {
      v.value && !v.value.contains(C.target) && (await de(), i.value = null);
    }
    async function Z() {
      if (typeof window < "u" && window.innerWidth <= 768) {
        const C = document.getElementById("advancedSearchMobile");
        C ? C.showModal() : console.warn("Modal element not found.");
      }
    }
    async function K(C) {
      var B;
      i.value = C, await de();
      const O = p.value[C.name];
      if (O) {
        const I = O.getBoundingClientRect(), g = ((B = v.value) == null ? void 0 : B.getBoundingClientRect()) || { left: 0, top: 0 };
        window.innerWidth > 768 ? b.value = {
          left: `${I.left + I.width / 2 - g.left}px`,
          top: `${I.bottom - g.top}px`,
          transform: "translateX(-50%)"
        } : b.value = {
          left: "50%",
          top: `${I.bottom - g.top}px`,
          transform: "translateX(-50%)"
          // Center the popup horizontally on mobile
        };
      } else
        console.error("Tab element not found for:", C.name);
    }
    return E(() => {
      document.addEventListener("click", j);
    }), Oe(() => {
      document.removeEventListener("click", j);
    }), (C, O) => {
      var B, I;
      return n(), o(y, null, [
        t("div", {
          ref_key: "searchContainer",
          ref: v,
          class: "w-full"
        }, [
          t("div", {
            class: "group/search relative flex place-items-center border-2 shadow-md p-2 border-base-300/25 rounded-sm w-full transition-all cursor-pointer md:cursor-auto",
            onClick: Z
          }, [
            t("div", st, [
              (n(!0), o(y, null, _(((B = e.searchOptions.find((g) => g.category === e.currentCategory)) == null ? void 0 : B.tabs) || [], (g) => {
                var D;
                return n(), o("button", {
                  key: g.name,
                  onClick: (V) => K(g),
                  class: k([{ "tab-active": ((D = i.value) == null ? void 0 : D.name) === g.name }, "group/searchitem relative after:top-0 after:-right-2 after:absolute first-of-type:flex-auto last-of-type:flex-auto md:after:content-[''] last-of-type:after:content-none after:content-none after:bg-base-200 hover:bg-base-200 p-1 rounded-sm w-auto after:w-[1px] after:h-10 text-start overflow-x-hidden pointer-events-none md:pointer-events-auto"]),
                  ref_for: !0,
                  ref: (V) => p.value[g.name] = V
                }, [
                  t("p", it, h(g.name), 1),
                  t("p", ut, h(g.description), 1)
                ], 10, rt);
              }), 128))
            ]),
            i.value ? (n(), o("div", {
              key: 0,
              class: "absolute flex shadow-sm mt-4 w-fit max-w-full transition-all tab-content",
              style: Ie(b.value)
            }, [
              (n(), re(ie(s[i.value.type]), ue(i.value.props ? i.value.props : null, { onUpdated: m }), null, 16))
            ], 4)) : S("", !0),
            t("button", {
              title: "search",
              type: "submit",
              class: "ml-1 btn btn-primary btn-square",
              onClick: f
            }, [
              W(A(ce), {
                size: 24,
                color: "white"
              })
            ])
          ]),
          t("div", dt, [
            t("button", {
              title: "search",
              onClick: O[0] || (O[0] = () => {
              })
            }, [
              W(A(ce), {
                size: 24,
                color: "white"
              })
            ])
          ])
        ], 512),
        t("dialog", ct, [
          t("div", pt, [
            w(C.$slots, "additionalForMobile", {}, () => [
              t("h3", mt, h(C.currentCategory), 1)
            ], !0),
            (n(!0), o(y, null, _(((I = e.searchOptions.find((g) => g.category === e.currentCategory)) == null ? void 0 : I.tabs) || [], (g, D) => (n(), o("div", {
              class: "bg-base-200 my-4 collapse",
              key: g.name
            }, [
              t("input", {
                type: "radio",
                name: "my-accordion-1",
                checked: D === 0
              }, null, 8, ft),
              t("div", vt, [
                ne(h(g.name) + " ", 1),
                t("p", gt, h(g.description), 1)
              ]),
              t("div", bt, [
                O[1] || (O[1] = t("br", null, null, -1)),
                (n(), re(ie(s[g.type]), ue({ ref_for: !0 }, g.props || {}, {
                  onUpdated: (V) => m(V, D)
                }), null, 16, ["onUpdated"]))
              ])
            ]))), 128)),
            t("div", { class: "modal-action" }, [
              t("form", { method: "dialog" }, [
                t("button", {
                  class: "btn btn-primary",
                  onClick: f
                }, "Close and Search")
              ])
            ])
          ])
        ])
      ], 64);
    };
  }
}), X = (d, u) => {
  const e = d.__vccOpts || d;
  for (const [a, i] of u)
    e[a] = i;
  return e;
}, $n = /* @__PURE__ */ X(ht, [["__scopeId", "data-v-08fa37eb"]]), yt = ["placeholder", "value", "id"], wt = ["id"], kt = {
  key: 0,
  class: "flex justify-between items-center place-content-center mb-4"
}, _t = ["value"], $t = ["value"], Ct = {
  key: 1,
  class: "gap-2 grid grid-cols-7"
}, St = ["onClick"], xt = {
  key: 2,
  class: "mt-4 lg:w-80"
}, Dt = {
  key: 0,
  class: "mb-2 font-bold text-lg"
}, Tt = { key: 1 }, Mt = {
  key: 1,
  class: "flex gap-4"
}, Bt = ["value"], Ot = ["value"], It = {
  key: 2,
  class: "flex flex-col gap-4"
}, Ut = {
  key: 1,
  class: "flex gap-2"
}, At = ["value"], Vt = ["value"], Pt = {
  key: 1,
  class: "flex gap-2"
}, Rt = ["value"], jt = ["value"], zt = { class: "flex gap-2 mt-4" }, Nt = {
  __name: "datetimePicker",
  props: {
    mode: {
      type: String,
      default: "datetime",
      // 'datetime', 'date', 'time'
      validator: (d) => ["datetime", "date", "time"].includes(d)
    },
    range: {
      type: Boolean,
      default: !1
    },
    placeholder: {
      type: String,
      default: "Select date and time"
    },
    popup: {
      type: Boolean,
      default: !1
    },
    id: {
      type: String,
      default: "datetimepicker"
    },
    initialDate: {
      type: Object,
      default: () => null
    }
  },
  emits: ["updated"],
  setup(d, { emit: u }) {
    const e = d;
    N(() => e.range, (r) => {
      r ? (s.value = { start: null, end: null }, p.value = { start: null, end: null }) : (s.value = null, p.value = null);
    });
    const a = u, i = $(!1), s = $(e.range ? { start: null, end: null } : null), p = $(e.range ? { start: null, end: null } : null), b = $((/* @__PURE__ */ new Date()).toLocaleString("default", { month: "long" })), v = $((/* @__PURE__ */ new Date()).getFullYear()), m = $(e.range ? { start: 0, end: 0 } : 0), f = $(e.range ? { start: 0, end: 0 } : 0), j = $(null), Z = x(() => `${e.id}-input`), K = x(() => `${e.id}-popup`), C = x(() => e.mode === "date" || e.mode === "datetime"), O = x(() => e.mode === "time" || e.mode === "datetime");
    x(() => new Date(v.value, B.value));
    const B = x(() => q.indexOf(b.value)), I = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"], g = x(() => new Date(v.value, B.value).getDay()), D = x(() => {
      const r = new Date(v.value, B.value + 1, 0).getDate();
      return Array.from({ length: r }, (c, l) => new Date(v.value, B.value, l + 1));
    }), V = x(() => Array.from({ length: g.value }, (r, c) => c)), G = Array.from({ length: 24 }, (r, c) => c), Q = Array.from({ length: 60 }, (r, c) => c), H = x(
      () => typeof navigator < "u" && /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(
        navigator.userAgent
      )
    ), q = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"], me = x(() => {
      const r = (/* @__PURE__ */ new Date()).getFullYear();
      return Array.from({ length: 100 }, (c, l) => r - 50 + l);
    }), fe = x(() => {
      if (!C.value || !s.value) return "";
      if (e.range && s.value.start && s.value.end) {
        const r = s.value.start.toLocaleDateString("en-US"), c = s.value.end.toLocaleDateString("en-US");
        return `${r} - ${c}`;
      }
      return !e.range && s.value ? s.value.toLocaleDateString("en-US") : "";
    }), L = (r) => r instanceof Date ? r : new Date(r), z = (r) => r instanceof Date && !isNaN(r), ve = x(() => {
      if (!O.value) return "";
      const r = (c) => {
        var Y, F, se;
        const l = ((Y = m.value) == null ? void 0 : Y[c]) ?? m.value, P = ((F = f.value) == null ? void 0 : F[c]) ?? f.value;
        return H.value ? ((se = p.value) == null ? void 0 : se[c]) ?? p.value : `${l.toString().padStart(2, "0")}:${P.toString().padStart(2, "0")}`;
      };
      return e.range ? `${r("start")} - ${r("end")}` : r();
    }), ge = x(() => {
      const r = fe.value, c = ve.value;
      return `${r} ${c}`.trim();
    }), be = () => i.value = !i.value, oe = () => {
      T(), he();
    }, he = () => i.value = !1, ye = () => {
      s.value = e.range ? { start: null, end: null } : null, p.value = e.range ? { start: null, end: null } : null, T();
    }, we = (r) => {
      e.range ? s.value.start && s.value.end ? s.value = { start: r, end: null } : s.value.start ? s.value.end = r : s.value.start = r : s.value = r, T();
    }, ke = (r) => (r = L(r), e.range ? s.value.start && z(s.value.start) && r.getTime() === s.value.start.getTime() || s.value.end && z(s.value.end) && r.getTime() === s.value.end.getTime() : z(s.value) && r.getTime() === s.value.getTime()), _e = (r) => {
      r = L(r);
      const c = /* @__PURE__ */ new Date();
      return r.getDate() === c.getDate() && r.getMonth() === c.getMonth() && r.getFullYear() === c.getFullYear();
    }, $e = (r) => (r = L(r), e.range && z(s.value.start) && r.getTime() === s.value.start.getTime()), Ce = (r) => (r = L(r), e.range && z(s.value.end) && r.getTime() === s.value.end.getTime()), Se = (r) => {
      if (r = L(r), e.range && z(s.value.start) && z(s.value.end)) {
        const c = s.value.start.getTime(), l = s.value.end.getTime(), P = r.getTime();
        return P > c && P < l;
      }
      return !1;
    }, xe = () => {
      let r = B.value - 1;
      r < 0 && (r = 11, v.value--), b.value = q[r], T();
    }, De = () => {
      let r = B.value + 1;
      r > 11 && (r = 0, v.value++), b.value = q[r], T();
    }, le = (r) => {
      j.value && !j.value.contains(r.target) && i.value == !0 && oe();
    }, T = () => {
      let r = {};
      const c = (l, P, Y) => {
        l instanceof Date && !isNaN(l) || (l = /* @__PURE__ */ new Date());
        const F = new Date(l);
        return F.setUTCHours(P, Y, 0, 0), F.toISOString();
      };
      e.range ? (r.from = c(
        s.value.start,
        m.value.start,
        f.value.start
      ), r.to = c(
        s.value.end,
        m.value.end,
        f.value.end
      )) : r = c(
        s.value,
        m.value,
        f.value
      ), a("updated", r);
    };
    return E(() => {
      e.initialDate && (e.range && e.initialDate.start && e.initialDate.end ? s.value = {
        start: new Date(e.initialDate.start),
        end: new Date(e.initialDate.end)
      } : e.initialDate.start && (s.value = { start: new Date(e.initialDate.start) })), e.range ? (m.value.start = m.value.start ?? (/* @__PURE__ */ new Date()).getHours(), m.value.end = m.value.end ?? (/* @__PURE__ */ new Date()).getHours(), f.value.start = f.value.start ?? (/* @__PURE__ */ new Date()).getMinutes(), f.value.end = f.value.end ?? (/* @__PURE__ */ new Date()).getMinutes()) : (m.value = m.value ?? (/* @__PURE__ */ new Date()).getHours(), f.value = f.value ?? (/* @__PURE__ */ new Date()).getMinutes());
    }), e.popup && E(() => document.addEventListener("click", le)), pe(() => document.removeEventListener("click", le)), (r, c) => (n(), o("div", {
      class: "inline-block relative w-full lg:w-[360px]",
      ref_key: "pickerContainer",
      ref: j
    }, [
      t("div", {
        class: "flex items-center gap-2 cursor-pointer",
        onClick: be
      }, [
        d.popup ? w(r.$slots, "default", { key: 0 }, () => [
          t("input", {
            type: "text",
            class: "input-bordered w-full cursor-pointer input",
            placeholder: d.placeholder,
            value: ge.value,
            readonly: "",
            id: Z.value
          }, null, 8, yt),
          c[11] || (c[11] = t("button", { class: "btn btn-ghost" }, " 📅 ", -1))
        ], !0) : S("", !0)
      ]),
      i.value || !d.popup ? (n(), o("div", {
        key: 0,
        class: k(["z-50 lg:bg-base-100 md:mt-2 md:p-4 px-4 rounded-md w-full", [{ absolute: d.popup }]]),
        id: K.value
      }, [
        C.value ? (n(), o("div", kt, [
          t("button", {
            class: "hidden md:block btn-outline btn btn-primary md:btn-sm",
            onClick: xe
          }, c[12] || (c[12] = [
            t("svg", {
              xmlns: "http://www.w3.org/2000/svg",
              class: "w-4 h-4",
              fill: "none",
              viewBox: "0 0 24 24",
              stroke: "currentColor"
            }, [
              t("path", {
                "stroke-linecap": "round",
                "stroke-linejoin": "round",
                "stroke-width": "2",
                d: "M15 19l-7-7 7-7"
              })
            ], -1)
          ])),
          U(t("select", {
            class: "border-none w-fit select",
            "onUpdate:modelValue": c[0] || (c[0] = (l) => b.value = l),
            onChange: T
          }, [
            (n(), o(y, null, _(q, (l, P) => t("option", {
              key: P,
              value: l
            }, h(l), 9, _t)), 64))
          ], 544), [
            [R, b.value]
          ]),
          U(t("select", {
            class: "border-none w-24 select",
            "onUpdate:modelValue": c[1] || (c[1] = (l) => v.value = l),
            onChange: T
          }, [
            (n(!0), o(y, null, _(me.value, (l) => (n(), o("option", {
              key: l,
              value: l
            }, h(l), 9, $t))), 128))
          ], 544), [
            [R, v.value]
          ]),
          t("button", {
            class: "hidden md:block btn-outline btn btn-primary md:btn-sm",
            onClick: De
          }, c[13] || (c[13] = [
            t("svg", {
              xmlns: "http://www.w3.org/2000/svg",
              class: "w-4 h-4",
              fill: "none",
              viewBox: "0 0 24 24",
              stroke: "currentColor"
            }, [
              t("path", {
                "stroke-linecap": "round",
                "stroke-linejoin": "round",
                "stroke-width": "2",
                d: "M9 5l7 7-7 7"
              })
            ], -1)
          ]))
        ])) : S("", !0),
        C.value ? (n(), o("div", Ct, [
          (n(), o(y, null, _(I, (l) => t("div", {
            key: l,
            class: "text-center"
          }, h(l), 1)), 64)),
          (n(!0), o(y, null, _(V.value, (l) => (n(), o("div", {
            key: l,
            class: "text-center"
          }))), 128)),
          (n(!0), o(y, null, _(D.value, (l) => (n(), o("div", {
            key: l,
            class: k(["hover:bg-primary-10 py-1 rounded-full text-center cursor-pointer", {
              "bg-primary text-primary-content": ke(l),
              today: _e(l),
              "range-start bg-primary text-primary-content": $e(l),
              "range-end bg-primary text-primary-content": Ce(l),
              "in-range bg-primary/20 hover:bg-primary/10": Se(l)
            }]),
            onClick: (P) => we(l)
          }, h(l.getDate()), 11, St))), 128))
        ])) : S("", !0),
        O.value ? (n(), o("div", xt, [
          e.range ? S("", !0) : (n(), o("h3", Dt, "Select Time")),
          e.range ? (n(), o("div", It, [
            t("div", null, [
              c[14] || (c[14] = t("p", { class: "font-bold" }, "Start Time", -1)),
              H.value ? U((n(), o("input", {
                key: 0,
                type: "time",
                class: "input-bordered w-full input",
                "onUpdate:modelValue": c[5] || (c[5] = (l) => p.value.start = l),
                onChange: T
              }, null, 544)), [
                [ee, p.value.start]
              ]) : (n(), o("div", Ut, [
                U(t("select", {
                  class: "w-full select-bordered select",
                  "onUpdate:modelValue": c[6] || (c[6] = (l) => m.value.start = l),
                  onChange: T
                }, [
                  (n(!0), o(y, null, _(A(G), (l) => (n(), o("option", {
                    key: l,
                    value: l
                  }, h(l.toString().padStart(2, "0")), 9, At))), 128))
                ], 544), [
                  [
                    R,
                    m.value.start,
                    void 0,
                    { number: !0 }
                  ]
                ]),
                U(t("select", {
                  class: "w-full select-bordered select",
                  "onUpdate:modelValue": c[7] || (c[7] = (l) => f.value.start = l),
                  onChange: T
                }, [
                  (n(!0), o(y, null, _(A(Q), (l) => (n(), o("option", {
                    key: l,
                    value: l
                  }, h(l.toString().padStart(2, "0")), 9, Vt))), 128))
                ], 544), [
                  [
                    R,
                    f.value.start,
                    void 0,
                    { number: !0 }
                  ]
                ])
              ]))
            ]),
            t("div", null, [
              c[15] || (c[15] = t("p", { class: "font-bold" }, "End Time", -1)),
              H.value ? U((n(), o("input", {
                key: 0,
                type: "time",
                class: "input-bordered w-full input",
                "onUpdate:modelValue": c[8] || (c[8] = (l) => p.value.end = l),
                onChange: T
              }, null, 544)), [
                [ee, p.value.end]
              ]) : (n(), o("div", Pt, [
                U(t("select", {
                  class: "w-full select-bordered select",
                  "onUpdate:modelValue": c[9] || (c[9] = (l) => m.value.end = l),
                  onChange: T
                }, [
                  (n(!0), o(y, null, _(A(G), (l) => (n(), o("option", {
                    key: l,
                    value: l
                  }, h(l.toString().padStart(2, "0")), 9, Rt))), 128))
                ], 544), [
                  [
                    R,
                    m.value.end,
                    void 0,
                    { number: !0 }
                  ]
                ]),
                U(t("select", {
                  class: "w-full select-bordered select",
                  "onUpdate:modelValue": c[10] || (c[10] = (l) => f.value.end = l),
                  onChange: T
                }, [
                  (n(!0), o(y, null, _(A(Q), (l) => (n(), o("option", {
                    key: l,
                    value: l
                  }, h(l.toString().padStart(2, "0")), 9, jt))), 128))
                ], 544), [
                  [
                    R,
                    f.value.end,
                    void 0,
                    { number: !0 }
                  ]
                ])
              ]))
            ])
          ])) : (n(), o("div", Tt, [
            H.value ? U((n(), o("input", {
              key: 0,
              type: "time",
              class: "input-bordered w-full input",
              "onUpdate:modelValue": c[2] || (c[2] = (l) => p.value = l),
              onChange: T
            }, null, 544)), [
              [ee, p.value]
            ]) : (n(), o("div", Mt, [
              U(t("select", {
                class: "w-full select-bordered select",
                "onUpdate:modelValue": c[3] || (c[3] = (l) => m.value = l),
                onChange: T
              }, [
                (n(!0), o(y, null, _(A(G), (l) => (n(), o("option", {
                  key: l,
                  value: l
                }, h(l.toString().padStart(2, "0")), 9, Bt))), 128))
              ], 544), [
                [
                  R,
                  m.value,
                  void 0,
                  { number: !0 }
                ]
              ]),
              U(t("select", {
                class: "w-full select-bordered select",
                "onUpdate:modelValue": c[4] || (c[4] = (l) => f.value = l),
                onChange: T
              }, [
                (n(!0), o(y, null, _(A(Q), (l) => (n(), o("option", {
                  key: l,
                  value: l
                }, h(l.toString().padStart(2, "0")), 9, Ot))), 128))
              ], 544), [
                [
                  R,
                  f.value,
                  void 0,
                  { number: !0 }
                ]
              ])
            ]))
          ]))
        ])) : S("", !0),
        t("div", zt, [
          t("button", {
            class: k(["btn btn-secondary", d.popup ? "w-fit" : "w-full"]),
            onClick: ye
          }, "Clear", 2),
          d.popup ? (n(), o("button", {
            key: 0,
            class: "btn btn-primary btn-wide",
            onClick: oe
          }, "Close")) : S("", !0)
        ])
      ], 10, wt)) : S("", !0)
    ], 512));
  }
}, Et = /* @__PURE__ */ X(Nt, [["__scopeId", "data-v-cb781ab6"]]), Lt = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  default: Et
}, Symbol.toStringTag, { value: "Module" })), Ft = ["value", "checked", "onChange", "disabled"], Cn = /* @__PURE__ */ M({
  __name: "rating",
  props: {
    initialRating: { default: 0 },
    numberOfStars: { default: 5 },
    halfStars: { type: Boolean, default: !0 },
    isInteractive: { type: Boolean, default: !1 },
    size: { default: "sm" }
  },
  setup(d) {
    const u = d, e = $(u.initialRating);
    N(
      () => u.initialRating,
      (i) => {
        e.value = i;
      }
    );
    const a = (i) => {
      e.value = i;
    };
    return (i, s) => (n(), o("div", {
      class: k(["rating", [
        `rating-${u.size}`,
        { "rating-half": i.halfStars }
      ]])
    }, [
      (n(!0), o(y, null, _(i.numberOfStars * (i.halfStars ? 2 : 1), (p) => (n(), o("input", {
        key: p,
        type: "radio",
        value: i.halfStars ? p * 0.5 : p,
        checked: e.value === (i.halfStars ? p * 0.5 : p),
        onChange: (b) => i.isInteractive ? a(i.halfStars ? p * 0.5 : p) : null,
        class: k(["mask mask-star", {
          "bg-yellow-400": e.value >= (i.halfStars ? p * 0.5 : p),
          "mask-half-1": i.halfStars && p % 2 !== 0,
          "mask-half-2": i.halfStars && p % 2 === 0,
          "cursor-pointer": i.isInteractive,
          "cursor-default": !i.isInteractive
        }]),
        disabled: !i.isInteractive
      }, null, 42, Ft))), 128))
    ], 2));
  }
}), Ht = {
  key: 0,
  class: "loading loading-spinner loading-md mx-auto"
}, Sn = /* @__PURE__ */ M({
  __name: "loader",
  props: {
    loading: { type: Boolean, default: !0 }
  },
  setup(d) {
    const u = d, e = $(u.loading);
    return N(
      () => u.loading,
      (a) => {
        e.value = a;
      }
    ), (a, i) => e.value ? (n(), o("span", Ht)) : S("", !0);
  }
}), qt = { class: "bg-base-200 mx-auto md:px-10 py-10 text-base-content" }, Yt = { class: "footer sm:footer-horizontal container" }, Jt = { class: "footer-title" }, Wt = ["href"], Xt = { class: "ml-auto" }, xn = /* @__PURE__ */ M({
  __name: "footer",
  props: {
    items: {}
  },
  setup(d) {
    const u = d;
    return (e, a) => (n(), o("div", qt, [
      t("footer", Yt, [
        (n(!0), o(y, null, _(u.items, (i) => (n(), o("nav", null, [
          t("h6", Jt, h(i.title), 1),
          (n(!0), o(y, null, _(i.items, (s) => (n(), o("a", {
            class: "link link-hover",
            href: s.link
          }, h(s.text), 9, Wt))), 256))
        ]))), 256)),
        t("aside", Xt, [
          w(e.$slots, "default")
        ])
      ])
    ]));
  }
}), Zt = {}, Kt = { class: "min-h-40 container hero" }, Gt = { class: "px-0! text-center hero-content" }, Qt = { class: "mt-9 text-4xl" };
function en(d, u) {
  return n(), o("div", Kt, [
    t("div", Gt, [
      t("div", null, [
        t("h1", Qt, [
          w(d.$slots, "title", {}, () => [
            u[0] || (u[0] = ne("hero title"))
          ])
        ]),
        t("p", null, [
          w(d.$slots, "description", { class: "py-9" })
        ]),
        w(d.$slots, "call-to-action-block", { class: "max-w-full" }, () => [
          u[1] || (u[1] = t("button", { class: "btn btn-primary" }, "Call to action", -1))
        ])
      ])
    ])
  ]);
}
const Dn = /* @__PURE__ */ X(Zt, [["render", en]]), tn = { class: "categories flex flex-row gap-4 place-content-center" }, nn = ["onClick"], Tn = /* @__PURE__ */ M({
  __name: "categoryNavigation",
  props: {
    searchOptions: {},
    currentCategory: {}
  },
  emits: ["update:currentCategory"],
  setup(d, { emit: u }) {
    const e = d, a = u;
    function i(s) {
      a("update:currentCategory", s);
    }
    return (s, p) => (n(), o("div", tn, [
      (n(!0), o(y, null, _(e.searchOptions, (b) => (n(), o("div", {
        key: b.category
      }, [
        t("button", {
          onClick: (v) => i(b.category),
          class: k(["truncate", { "font-semibold": e.currentCategory === b.category }])
        }, h(b.category), 11, nn)
      ]))), 128))
    ]));
  }
}), an = { class: "md:flex hidden navbar-start" }, on = { class: "md:flex justify-center items-center hidden navbar-center" }, ln = { class: "md:flex hidden navbar-end" }, sn = { class: "navbar-bottom md:flex hidden" }, rn = /* @__PURE__ */ M({
  __name: "navigationBar",
  props: {
    isCollapsed: { type: Boolean, default: !0 }
  },
  setup(d) {
    const u = d;
    return (e, a) => (n(), o("nav", {
      class: k(["place-items-start border-primary bg-base-100 px-5 py-5 border-b-4 transition-all navbar navigationbar", u.isCollapsed ? "collapsed" : ""])
    }, [
      t("div", an, [
        w(e.$slots, "start", {}, void 0, !0)
      ]),
      t("div", on, [
        w(e.$slots, "center", {}, void 0, !0)
      ]),
      t("div", ln, [
        w(e.$slots, "end", {}, void 0, !0)
      ]),
      t("div", sn, [
        w(e.$slots, "bottom", {}, void 0, !0)
      ])
    ], 2));
  }
}), Mn = /* @__PURE__ */ X(rn, [["__scopeId", "data-v-8ddb2b45"]]), un = {
  role: "tablist",
  class: "relative tabs-bordered w-full tabs tabs-lg"
}, dn = {
  key: 0,
  class: "hidden top-4 right-0 absolute md:flex gap-4"
}, cn = ["onClick", "aria-selected"], pn = {
  key: 0,
  role: "tabpanel",
  class: "p-6 border-x-0 border-t-2 border-b-0 border-base-300 max-w-full overflow-x-auto tab-content"
}, Bn = /* @__PURE__ */ M({
  __name: "tab",
  props: {
    items: {},
    withControlls: { type: Boolean, default: !1 },
    rotateTabsAfter: { default: 0 },
    buttonOnlyMode: { type: Boolean, default: !1 }
  },
  emits: ["tab-changed"],
  setup(d, { emit: u }) {
    const e = d, a = $(e.items[0]), i = u;
    function s(v) {
      a.value = v, i("tab-changed", v);
    }
    function p() {
      const m = (e.items.indexOf(a.value) + 1) % e.items.length;
      s(e.items[m]);
    }
    function b() {
      const m = (e.items.indexOf(a.value) - 1 + e.items.length) % e.items.length;
      s(e.items[m]);
    }
    return E(() => {
      e.items && s(e.items[0]);
    }), pe(() => {
      e.rotateTabsAfter && e.rotateTabsAfter > 0 && setInterval(() => {
        p();
      }, e.rotateTabsAfter * 1e3);
    }), (v, m) => (n(), o("div", un, [
      v.withControlls ? (n(), o("div", dn, [
        t("button", {
          onClick: m[0] || (m[0] = (f) => b()),
          class: "cursor-pointer"
        }, "Previous"),
        t("button", {
          onClick: m[1] || (m[1] = (f) => p()),
          class: "text-primary cursor-pointer"
        }, "Next")
      ])) : S("", !0),
      (n(!0), o(y, null, _(v.items, (f) => (n(), o(y, null, [
        t("a", {
          type: "button",
          role: "tab",
          class: k(["min-w-max tab", f === a.value ? "bg-primary text-base-100" : ""]),
          onClick: (j) => s(f),
          "aria-selected": a.value == f
        }, h(f), 11, cn),
        v.buttonOnlyMode ? S("", !0) : (n(), o("div", pn, [
          w(v.$slots, `${f}-tab`)
        ]))
      ], 64))), 256))
    ]));
  }
});
export {
  yn as Accordion,
  $n as AdvancedSearch,
  wn as Avatar,
  kn as Badge,
  fn as ButtonComponent,
  _n as Card,
  Tn as CategoryNavigation,
  Et as DatetimePicker,
  vn as Dropdown,
  xn as Footer,
  Dn as Hero,
  Sn as Loader,
  gn as Modal,
  Mn as NavigationBar,
  Cn as Rating,
  bn as Swap,
  Bn as Tab,
  hn as ThemeController
};
